//######################################################################################
// FM-LIB++ version 1.0 (Septembre 2001).
// Copyright (c) 2001-2002 Achraf cherti.
//                                        
// Librairie C de lecture des fichier *.fms cres avec le Tracker FmSong pour
// LINUX & DJGPP.
// Copyright (c) Achraf cherti, Thunder software 2001.
//
// Site officiel: http://fmsong.cjb.net
//
// Si vous avez des questions,critiques,remarques... n'hesitez surtout pas
// a m'envoyer un EMail: achrafcherti@hotmail.com
//
// Vous pouvez utiliser cette librairie pour but COMMERCIAL ou NON mais
// vous devez respecter les termes et conditions de l'auteur dans le DOC qui
// accompagne ce SOFTWARE.
//
// Remerciments speciales:
// ~~~~~~~~~~~~~~~~~~~~~~~
// DjDelories:    pour DJGPP c'est pour moi le meilleur compilateur C du moment
//	          www.delories.com ou www.djgpp.com.
// Robert hone:  c'est l'auteur de Rhide l'EDI de DJGPP aussi un tres bon software qui vous
// 		  facilite beaucoup de choses.
// Vous:          Car sans vous tout ce travail ne serait jamais fait.
//
// Info express:
// ~~~~~~~~~~~~~~
// Vous tes un programmeur Qbasic alors ne paniquez pas dans le site officiel il
// "http://fmsong.cjb.net" y a aussi une librairie FmLib pour le Qbasic.
//
// Je vous remercie pour l'interet que vous pourtez pour FmSong...
//
//######################################################################################

#ifndef __FMlib__
#define __FMlib__

#include <stdlib.h>     /* Allocation mmoire dynamique*/
#include <string.h>     /*memcpy*/
#include <stdio.h>      /* standar I/O pour les fichiers*/
#include <io.h>         /* open close...*/
#include <fcntl.h>      /* constantes open de io.h */
#include <bios.h>       /* biostime */

char *loadfms_error[] = {"Fichier non trouv",
                         "Format de fichier FMS incorrect",
			 "Fichier dfectueux",
			 "Pas assez de mmoire"};

#define X -1
#define C 1
#define D 2
#define E 3
#define F 4
#define G 5
#define A 6
#define B 7

//pour definir la carte mono ou stereo
#define MONO 0
#define STEREO 1

//Code de retour de LOOPFMS
#define FMS_STOP    0
#define FMS_PLAY    1

//-- Strucuture d'un instruments
typedef struct
{
        unsigned char attack[2], decay[2], sustain[2], released[2];
        unsigned char outp[2], amplitudevibrato[2];
        unsigned char scalling[2],waveselect[2],pitchvibrato[2];
        unsigned char frequencymultipler[2];
        unsigned char enveloppescalling[2];
        unsigned char sustaininglevel[2];
        unsigned char feedback,connection;
        char iname[9];
} INSTRUMENT;
//-- structure de 9 notes de 9 channels
typedef struct
{
        char octave[9],note[9];        //octave ou note
        char diese[9];     // 1 ou 0
} NOTE;
//-- structure d'un tracks
typedef struct
{
        NOTE *note;            //les notes
        short maxnote;
        short trackdelay;
        char enabled[9];       //les channels ENABLED
} TRACK;
//-- Structure principale d'un FMS
typedef struct
{
        TRACK *track;             //adresse pour 1000 tracks et 9 channels
        short maxtrack;            //la maximum de tracks
        short trackactuel,loopnote;
        int looptime;

        char titre[21];          //le titre
        char auteur[21];         //le titre
        char commentaire[51];    //le titre
        INSTRUMENT ins[9];       //les instruments
} FMS;

FMS *pfms = (FMS *) 0;

//############# LE PORT FM #######################
short base_port = 0x300;
short reg_port = 0x388;   //port de base
short data_port = 0x389;   //port de base

short reg_port2 = 0;
short data_port2 = 0;

//short reg_port = 0x220;   //port de base
//short data_port = 0x221;   //port de DATA
//short reg_port2 = 0x222;   //port de base short reg_port = 0x388;   //port de base
//short data_port2 = 0x223;   //port de DATA II pour ST

short output_type = MONO;
//############# LE PORT FM #######################

//----------------------------------------------------------------
//########### DECLARATION DES SUBS ET FONCTIONS ##################
//----------------------------------------------------------------
void playfms(FMS *musique,short loop);
void stopfms();
void pausefms(void);
void resumefms(void);
void writereg(unsigned char reg,unsigned char value);
void sendinstrument(char channel,INSTRUMENT myins);
char playnote(char channel,char note,char diese,char oct);
short adlib_init(void);
short detectbaseport(void);
void fmsvolume(char voll,char volr);
short fmsonginit(void);
char loopfms(void);
void fmsongclose(void);
void copyinstrument(INSTRUMENT *source,INSTRUMENT *destination);
char note2char(short note);
void freefms(FMS *musique);
short setmaxtrack(FMS *fms,short maxtrack);
short freemaxtrack(FMS *fms);
short freemaxnote(TRACK *track);
short setmaxnote(TRACK *track,short maxnote);
short loadins(char *filename,INSTRUMENT *myins);
void send_fms_instruments(FMS *musique);
void resetvars(FMS *musique);
char loadfms(FMS *musique,char *fichier);
//----------------------------------------------------------------

//les frquences des NOTES CDEFGAB et disses
unsigned short NOTE_FREQ[12] = {
                                 0x16B,0x181,0x198,
                                 0x1B0,0x1CA,0x1E5,
                                 0x202,0x220,0x241,
                                 0x263,0x287,0x2AE
                                };

//configurationu squensceur
short looped=1;  //par dfaud LOOPED=TRUE
short isplay=0;  //si il play
short ispause=0; //si pause

//##########################################################
// Affiche l'erreur de LOADFMS
//##########################################################
short print_loadfms_error(char error)
{
        if(error==0) return 1;
        printf("%s",loadfms_error[error-1]);
        return 0;
}
//##########################################################
// Commence le jeu du FMS
//##########################################################
void playfms(FMS *musique,short loop)
{
        short i;
        if(isplay)
              for(i=0;i<9;i++) playnote(i,X,0,0);       //stoppe toutes les notes

        isplay = 1;
        ispause = 0;
        pfms = musique;
        send_fms_instruments(musique);
        looped = loop;
        if(looped!=0) looped = 1;
}

//##########################################################
// stoppe le FMS
//##########################################################
void stopfms()
{
      short i;
      for(i=0;i<9;i++) playnote(i,X,0,0);       //stoppe toutes les notes
      isplay = 0;
      ispause = 0;
      if(pfms!=0)
        {
          pfms->trackactuel = 0;
          pfms->loopnote = 0;
          pfms = (FMS *) 0;
        }
}

//##########################################################
// PAUSE
//##########################################################
void pausefms(void)
{
        if(pfms!=0) ispause = 1;
}
//##########################################################
// RESUME
//##########################################################
void resumefms(void)
{
        if(pfms!=0) ispause = 0;
}
//##########################################################
// WriteReg crit dans me registre de la carte son
//##########################################################
void writereg(unsigned char reg,unsigned char value)
{
    short d;

if(!output_type)	//si mono
{
    outp(reg_port, reg);
    for(d=0;d<6;d++) inp(reg_port);
    outp(data_port, value);
    for(d=0;d<35;d++) inp(reg_port);
}
else
{
    outp(reg_port, reg);
    for(d=0;d<6;d++) inp(reg_port);
    outp(reg_port2, reg);
    for(d=0;d<6;d++) inp(reg_port);
    outp(data_port, value);
    for(d=0;d<35;d++) inp(reg_port);
    outp(data_port2, value);
    for(d=0;d<35;d++) inp(reg_port);
}
}
//#########################################################
// Envoie un instrument dans le channel spcifi
//#########################################################
void sendinstrument(char channel,INSTRUMENT myins)
{
        short _carplus,_modplus;
        short r[11];
        short variable[11];
        short i;

        switch(channel)
        {
          case 0:
                _carplus = 0;
                _modplus = 3;
                break;

          case 1:
                _carplus = 1;
                _modplus = 4;
                break;

          case 2:
                _carplus = 2;
                _modplus = 0x05;
                break;

          case 3:
                _carplus = 8;
                _modplus = 0xB;
                break;

          case 4:
                _carplus = 9;
                _modplus = 0xC;
                break;

          case 5:
                _carplus = 10;
                _modplus = 0XD;
                break;

          case 6:
                _carplus = 0x10;
                _modplus = 0x13;
                break;

          case 7:
                _carplus = 0x11;
                _modplus = 0x14;
                break;

          case 8:
                _carplus = 0x12;
                _modplus = 0x15;
                break;
        }

        //maintenant il met en place les ports
        r[0] = 0x20 + _carplus;
        r[1] = 0x20 + _modplus;
        r[2] = 0x40 + _carplus;
        r[3] = 0x40 +  _modplus;
        r[4] = 0x60 + _carplus;
        r[5] = 0x60 + _modplus;
        r[6] = 0x80 + _carplus;
        r[7] = 0x80 + _modplus;
        r[8] = 224 + _carplus;
        r[9] = 227 + _carplus;
        r[10] = 192 + channel;

        //Ici il met les valeurs
	variable[0]=0;
	if(myins.pitchvibrato[0]!=0) variable[0]+=128;
	if(myins.amplitudevibrato[0]!=0) variable[0]+=64;
	if(myins.sustaininglevel[0]!=0) variable[0]+=32;
	if(myins.enveloppescalling[0]!=0) variable[0]+=16;
	variable[0]+=myins.frequencymultipler[0];

	variable[1]=0;
	if(myins.pitchvibrato[1]!=0) variable[1]+=128;
	if(myins.amplitudevibrato[1]!=0) variable[1]+=64;
	if(myins.sustaininglevel[1]!=0) variable[1]+=32;
	if(myins.enveloppescalling[1]!=0) variable[1]+=16;
	variable[1]+=myins.frequencymultipler[1];

        variable[2] = (short)((myins.scalling[0]*64) + myins.outp[0]);
        variable[3] = (short)((myins.scalling[1]*64) + myins.outp[1]);

        variable[4] = (short)((myins.attack[0]*16) + myins.decay[0]);
        variable[5] = (short)((myins.attack[1]*16) + myins.decay[1]);

        variable[6] = (short)((myins.sustain[0]*16) + myins.released[0]);
        variable[7] = (short)((myins.sustain[1]*16) + myins.released[1]);

        variable[8] = (short)(myins.waveselect[0]);
        variable[9] = (short)(myins.waveselect[1]);

        variable[10] = (short)((myins.feedback * 2) + myins.connection);                

        //il envoie les donnes au port
        for(i=0;i<11;i++)
                   writereg(r[i],variable[i]);
}

//################################################################
// Joue une note dans un channel
//################################################################
char playnote(char channel,char note,char diese,char oct)
{
        short frequence;
        char p;
        short sans_diese[7] = {0,2,4,5,7,9,11};
        short avec_diese[7] = {1,3,-1,6,8,10,-1};

        if(note==0) return 0;

        writereg(0xA0 + channel,0);
        writereg(0xB0 + channel,0);

        if(note == -1) return 0;    //si note X alors quitter

        if(diese)	//0 si diese 1 si pas diese
                 p = avec_diese[note-1];
        else
                 p = sans_diese[note-1];

        if(p==-1) return 0;

        frequence = NOTE_FREQ[p];

        writereg(0xA0 + channel, (unsigned char)(frequence&0xFF));
        writereg(0xB0 + channel, (unsigned char)((frequence>>8)|32|(oct<<2)));

}


short adlib_init(void)
{
        unsigned char data1,data2;
        unsigned short d;

        /*reg_port = 0x388;
	data_port = 0x389;
	output_type = MONO;*/

        writereg(4, 0x60);
        writereg(4, 0x80);
        data1 = inp(0x388);
        writereg(2,0xFF);
        writereg(4, 0x21);
        for(d=0;d<150;d++) inp(0x388);
        data2 = inp(0x388);
        writereg(4,0x60);
        writereg(4,0x80);
        if(((data1 & 0xE0) == 0) && ((data2 & 0xE0) == 0xC0))
                                return 0;
        else
                                return 1;
}

//###########################################################################
// Trouve le port de base ou 100% compatible
//###########################################################################
short detectbaseport(void)
{
	short port=0,count=0,stat=0;

	for(port=0x20;port<=0x280;port+=0x10)
	  {
		outp(port+0x6, 1);
		for(count=1;count<=100;count++)
		   {
			outp(port+0x6,0);
			stat = inp(port+0xE);
			stat = inp(port+0xA);
		   }
		if(stat==0xAA) 	//si c'est detection OK
		   {
				return port;
		   }
	  }

	return 0;
}

//###########################################################################
// change le volume
//###########################################################################
void fmsvolume(char voll,char volr)
{
        if(voll>15) voll=15;
        if(volr>15) volr=15;
        if(voll<0) voll=0;
        if(volr<0) volr=0;

        outp(base_port+4,0x22);
        outp(base_port+5, (voll+ (volr*16))&0xFF);
}

//###########################################################################
// Detecte si la carte Fm est installe retourne NULL si oui 1 (true) si non
//###########################################################################
short fmsonginit(void)
{
	short base;

	base = detectbaseport();

	if(base==0) return 1;

	fmsvolume(15,15);       //met le volume  font

        base_port = base;      //
	reg_port = base + 8;   // configuration de la carte
	data_port = base + 9;  // FM avec tout les registres de base
	output_type = MONO;    //

        return 0;       //retourne OK
}

//#################################################################
// LOOP FMS la boucle principale qui joue la musique...
//#################################################################
char loopfms(void)
{
        short i=0,k=0;

        if(!isplay) return 0;   //s'il n'est pas en play alors ne pas jouer
        if(!pfms) return 0;     //si ce n'est pas un FMS
        if(ispause) return 0;   //si il est en pause alors quitter
        if(pfms->maxtrack==0) return 0; //si la fin de la musique

        //si pas encore temps alors quitter la SUB
        if(biostime(0,0)-pfms->looptime<pfms->track[pfms->trackactuel].trackdelay>>1)
                                      return 1;          //pas le temps
        else
                                      pfms->looptime = biostime(0,0);   //met le timer actuel

	
        //met le note dans le haut parleur
        for(k=0;k<9;k++)
              {
                     if(!pfms->track[pfms->trackactuel].enabled[k])
                      {
                          playnote(k,
                          pfms->track[pfms->trackactuel].note[pfms->loopnote].note[k],
                          pfms->track[pfms->trackactuel].note[pfms->loopnote].diese[k],
                          pfms->track[pfms->trackactuel].note[pfms->loopnote].octave[k]);
                      }
             }

       //retourne 1 si la fin de la musique
         if(!looped)
          {
           if(pfms->trackactuel==pfms->maxtrack-1 && pfms->loopnote==pfms->track[pfms->trackactuel].maxnote-1)
                                                       {
                                                          stopfms();
                                                          return 1;   //1 il ne joue pas
                                                       }
          }

       //change la note actuelle
        pfms->loopnote = (pfms->loopnote + 1)%(pfms->track[pfms->trackactuel].maxnote);

        //si loopnote termine le track alors passer au track suivant
        if(pfms->loopnote==0)
          {
                pfms->trackactuel = (pfms->trackactuel + 1)%(pfms->maxtrack);
          }
      
      return 1; //1 c'est play
}

//#################################################################
// Unload FmLib
//#################################################################
void fmsongclose(void)
{
    short i;

    writereg(0xA0,0x00);
    writereg(0xB0,0x11);

    for(i=0;i<=224;i++)
                writereg(i,0);   //resetFM
}

//########################################################################
// Copier le premier instrument dans le deuxime
//########################################################################
void copyinstrument(INSTRUMENT *source,INSTRUMENT *destination)
{
          memcpy(destination,source,sizeof(INSTRUMENT));
}

//########################################################################
// note2char convertit par exemple 1 pour C 2 pout G -1 pour X
//########################################################################
char note2char(short note)
{
        char *str = "CDEFGAB";

        if(note==0) return ' ';
        if(note==-1) return 'X';

        if(note>7) note = 7;
        if(note<0) note = 1;

        return str[note-1];
}
//########################################################################
// desalocation mmoire du FMS
//########################################################################
void freefms(FMS *musique)
{
        short j,i;
        
        if(musique->maxtrack>0)
           {
                 for(i=0;i<musique->maxtrack;i++)
                   {
                           free(musique->track[i].note);
                   }   
                free(musique->track);
          }
}

//####################################################################
// ALLOCATION MEMOIRE DE TRACKS
//####################################################################
short setmaxtrack(FMS *fms,short maxtrack)
{
        short i;

        fms->maxtrack = maxtrack;
        fms->track = (TRACK *) malloc(maxtrack*sizeof(TRACK));
        if(!fms->track) return 1;

        fms->looptime = 0;
        fms->loopnote = 0;
        fms->trackactuel = 0;
                
        for(i=0;i<maxtrack;i++)
           {
                fms->track[i].maxnote = 0;
                fms->track[i].trackdelay = 0;
                fms->track[i].note = (NOTE *) 0;
           }
        return 0;
}

//####################################################################
// DESALLOCATION MEMOIRE DE TRACKS
//####################################################################
short freemaxtrack(FMS *fms)
{
        free(fms->track);
        fms->maxtrack = 0;
        return 0;
}
//####################################################################
// DESALLOCATION MEMOIRE DE NOTES
//####################################################################
short freemaxnote(TRACK *track)
{
        free(track->note);
        return 0;
}

//####################################################################
// ALLOCATION MEMOIRE DE NOTES
//####################################################################
short setmaxnote(TRACK *track,short maxnote)
{
        short i,j;
        track->maxnote = maxnote;
        track->note = (NOTE *) malloc(maxnote*sizeof(NOTE));
        if(!track->note)
                        return 1;       //erreur d'allocation mmoire

        for(i=0;i<maxnote;i++)
         {
              for(j=0;j<9;j++)
                {
                    track->note[i].octave[j] = 0;
                    track->note[i].diese[j] = 0;
                    track->note[i].note[j] = 0;
                }
         }

        return 0;
}

//####################################################################
// charge un instrument dans u type INSTRUMENT
//####################################################################
short loadins(char *filename,INSTRUMENT *myins)
{
}

//#################################################################
// Met les instruments d'un FMS dans les 9 channels
//#################################################################
void send_fms_instruments(FMS *musique)
{
    short i;

    for(i=0;i<9;i++)
          {
                sendinstrument(i,musique->ins[i]);
          }
}

void resetvars(FMS *musique)
{
        musique->maxtrack = 0;  //maxtrack  0
        musique->trackactuel = 0;  //maxtrack  0
        musique->loopnote = 0;  //maxtrack  0
}

//#################################################################
// Procdure pour Charger un fichier *.FMS
// Les codes d'erreurs:
//              1 fichier non trouv ou impossible  ouvrir
//              2 format de fichier incorrect
//              3 fichier defectueux
//              4 pas assez de mmoire
//#################################################################
char loadfms(FMS *musique,char *fichier)
{
        unsigned char n=0;       //la note
        char *header = "fm-song-project";
        char header2[16];
        int file;
        int nbcarac;
        short i,j,k,l;

        resetvars(musique);

        //ouvre le fichier en lecture BINAIRE
        file = open(fichier,O_BINARY|O_RDONLY);
        if(file==-1)
                                       return 1;

        //teste si c'est un bon FMS
        nbcarac = read(file,(char *)header2,15);
        header2[15] = 0;  //pour qu'il soit un string

        if(strcmp(header,header2)!=0)
                                     {
                                        
                                        close(file);
                                        return 2;
                                     }
        //prend les proprits
        nbcarac = read(file,(char *)musique->titre,20);
        musique->titre[20] = 0;
        nbcarac = read(file,(char *)musique->auteur,20);
        musique->auteur[20] = 0;
        nbcarac = read(file,(char *)musique->commentaire,50);
        musique->commentaire[50] = 0;
        //s'il ne peut lire ceci... il retourne l'erreur
        if(nbcarac<=0)
                      {
                                close(file);
                                return 3;
                      }

        //prend le max track
        musique->maxtrack = 0;
        nbcarac = read(file,(short *)&musique->maxtrack,2);
        //allocation mmoire
        if(setmaxtrack(musique,musique->maxtrack))
          {
                     close(file);
                     return 4;    //pas assez de mmoire
          }

        //chargement des 8 instruments de musique
        for(k=0;k<8;k++)
          {
                nbcarac = read(file,(char *)musique->ins[k].iname,8);
                musique->ins[k].iname[8] = 0;

                read(file,&musique->ins[k].attack[0],1);
                read(file,&musique->ins[k].attack[1],1);

                read(file,&musique->ins[k].decay[0],1);
                read(file,&musique->ins[k].decay[1],1);

                read(file,&musique->ins[k].sustain[0],1);
                read(file,&musique->ins[k].sustain[1],1);

                read(file,&musique->ins[k].released[0],1);
                read(file,&musique->ins[k].released[1],1);

                read(file,&musique->ins[k].outp[0],1);
                read(file,&musique->ins[k].outp[1],1);

                read(file,&musique->ins[k].scalling[0],1);
                read(file,&musique->ins[k].scalling[1],1);

                read(file,&musique->ins[k].amplitudevibrato[0],1);
                read(file,&musique->ins[k].amplitudevibrato[1],1);

                read(file,&musique->ins[k].pitchvibrato[0],1);
                read(file,&musique->ins[k].pitchvibrato[1],1);

                read(file,&musique->ins[k].frequencymultipler[0],1);
                read(file,&musique->ins[k].frequencymultipler[1],1);

                read(file,&musique->ins[k].enveloppescalling[0],1);
                read(file,&musique->ins[k].enveloppescalling[1],1);

                read(file,&musique->ins[k].waveselect[0],1);
                read(file,&musique->ins[k].waveselect[1],1);

                read(file,&musique->ins[k].feedback,1);
                read(file,&musique->ins[k].connection,1);

                read(file,&musique->ins[k].sustaininglevel[0],1);
                read(file,&musique->ins[k].sustaininglevel[1],1);
          }

        for(i=0;i<musique->maxtrack;i++)
          {
                nbcarac = read(file,(short *)&musique->track[i].maxnote,2);
                nbcarac = read(file,(short *)&musique->track[i].trackdelay,2);
                musique->track[i].trackdelay*=2;
                //Allocation du max de tracks
                n = setmaxnote(&musique->track[i],musique->track[i].maxnote);
                if(n)
                  {
                        //desallocation mmoire
                        for(j=0;j<=i;j++)
                                         freemaxnote(&musique->track[j]);
                        freemaxtrack(musique);
                        return 4;       //pas assez de mmoire
                        close(file);
                  }

                if(nbcarac<=0)
                           {
                                //desallocation mmoire
                                for(j=0;j<=i;j++)
                                         freemaxnote(&musique->track[j]);
                                freemaxtrack(musique);
                                close(file);
                                return 3;
                           }

                //les channels.enabled
                for(j=0;j<8;j++)
                      {
                              read(file,&musique->track[i].enabled[j],1);
                      }
                musique->track[i].enabled[8] = 1;    //false le track 9

                //l il charge les notes dans les 8 channels
                for(k=0;k<8;k++)
                      {
                          for(j=0;j<musique->track[i].maxnote;j++)
                              {
                                 nbcarac = read(file,&n,1);
                                 if(nbcarac<=0)
                                        {
                                                //desallocation mmoire
                                                for(j=0;j<=i;j++)
                                                                 freemaxnote(&musique->track[j]);
                                                freemaxtrack(musique);

                                                close(file);
                                                return 3;
                                        }
                                                                               
                                 musique->track[i].note[j].octave[k] = (char)((n&56)>>3); // /8
                                 musique->track[i].note[j].note[k] = (unsigned char)n&7;
                                 musique->track[i].note[j].diese[k] = ((n&64)>>6); // *64/64

                                 if(musique->track[i].note[j].diese[k]!=0)
                                         musique->track[i].note[j].diese[k] = 1;

                                 if((char)((n&128)/128)==1) musique->track[i].note[j].note[k]=-1;
                               }
                      }
          }


        close(file);


        return 0;
}

#endif






