//###################################################################
// Header du programme Fms2Mid "Routines de conversion".
// Copyright (c) Achraf cherti 2001
//
// Email:   achrafcherti@hotmail.com
// FmSong:  http://fmsong.cjb.net
//###################################################################

#ifndef __fms2mid_convert__
#define __fms2mid_convert__

#include "init.h"	//fichier d'initialisation

void pitchchange(char channel,char bb,char ff);
int mywrite(int fd, const void *buffer, int count);
void write_header(void);
void write_eof(void);
void write_lenght_of_track(void);
void changer_instrument(char channel,char instrument);
void keyboardoff(char channel,char note,char velocity);
short keyboardon(char channel,char note,char velocity);
void controlchange(char channel,char controllernumber,char newvalue);
char fms2midi(char note,char diese,char octave);
void FMS2MID(void);

//##########################################################################
// La routine principale qui convertit un fichier *.FMS en fichier *.MID
//##########################################################################
void FMS2MID(void)
{
        int i=0,j=0,k=0,l=0,d=0;    //variables de boucle
        short per = 0;        //1 si percussion
        short plus=0;
        short kret = 0; 
        char mnote=0;
        char note=0,octave=0,diese=0,midinote[8],note_enabled[8];

        for(i=0;i<8;i++) //met les instruments dans le fichier midi.
            {
                changer_instrument(i,midi_instruments[i]);
                zero = 5;
                pitchchange(i,0x00,0x40);
                controlchange(i,0x40,0x00);
                midinote[i] = -1;     //midinote en profite pour avoir des valeur -1
            }

        // Conversion du fichier *.FMS en fichier *.MID
        for(i=0;i<musique->maxtrack;i++)   //les tracks
          {
            for(j=0;j<musique->track[i].maxnote;j++)   //les notes
              {
                  zero = 0;
                  for(k=0;k<8;k++)      //les channels
                     {
                       plus = k;        //le plus c'est k logique car k c'est le
                                        //numro de channel actuel
                       per = 0;         //le numro de note de percussion si il y en
                                        //a (percussion).

                       if(percussi[k]!=0)
                        {
                                per = percu_note[k];    //met le key de percussion
                                plus = 9;               //et le channel de percussion
                        }

                       mnote = midinote[k];

                       if(!enabled[k])    //si le channel n'est pas enabled alors passer...
                                      continue;

                       //si le channel est enabled il extracte note,octave,diese
                       if(!musique->track[i].enabled[k])
                        {
                            note = musique->track[i].note[j].note[k];
                            octave = musique->track[i].note[j].octave[k];
                            diese = musique->track[i].note[j].diese[k];
                            if(diese!=0)
                                        diese=1;
                        }
                       else     //s'il n'est pas enabled alors met tout  0
                        {
                             note=0;
                             octave=0;
                             diese=0;
                        }

                        if(note==-1)    //si stopper la voice
                          {

                              if(midinote[k]!=-1)    //stoppe le clavier
                                {
                                   if(!percussi[k])      //si pas percussi (car si en fait un
                                    {                    //stop dans la percussion il peut stopper
                                                         //un autre percussion sans le savoir dans le
                                                         //channel 10.

                                        keyboardoff(plus,midinote[k],0);
                                        midinote[k] = -1;
                                    }
                                }
                          }
                        else            //si pas stopper la voice alors play !!!
                          {

                                if(note>0)      //met KEYON si la note>1
                                   {
                                      if(midinote[k]!=-1)    //s'il doit stopper le clavier
                                       {
                                           if(!percussi[k])
                                           {
                                              keyboardoff(plus,midinote[k],0);
                                              midinote[k] = -1;
                                           }
                                       }
                                       //convertit la note FmSong en note General midi
                                       midinote[k] = fms2midi(note,diese,octave);

                                       if(percussi[k])  //si percussion alors...
                                       {
                                                kret = keyboardon(plus,per,volume[k]);
                                       }
                                       else             //sinon...
                                       {
                                                kret = keyboardon(plus,midinote[k],volume[k]);
                                       }

                                       //si erreur disque plein ou protg en criture...
                                       if(kret==0 || kret==-1)
 				        {
                                                close_files();
                                                remove(file_destination);       //efface le midi
                                                printf("\nErreur, disque plein ou protg en criture...\n",file_destination);
                                                exit(1);
 				        }


                                   }
                          }

                     }

                  //Si le delay >7 alors il devient 7 car un delta time ne
                  //dpasse pas 127 (de 0  127).
                  if(musique->track[i].trackdelay>>1>7)
                                        musique->track[i].trackdelay = 7<<1;

                  //met le zero (c'est le delta time) pour une petite
                  //pause dans l'instruction suivante
                  zero = 15;   //0.1 seconde

                  //met le delay
                  for(d=0;d<musique->track[i].trackdelay>>1;d++)
                                               keyboardoff(12,1,0);  //une petite pause si c'est pas la dernire note
              }
          }

        write_eof();        //crit le fin du MIDI
        close_files();      //Ferme les fichiers
}


//#############################################################
// Met tout les instruments dans la table midi_instruments
//#############################################################
void make_instruments(void)
{
        short j,i;
        char buffer[256];
        char buffer2[256];
        char buffer3[256];
        short num;
        char ini_file[256];
        int temp;

        strcpy(ini_file,path);
        strcat(ini_file,"\\fms_ins.ini");

        for(i=0;i<8;i++)
          {
               lcase(musique->ins[i].iname);
               trim(musique->ins[i].iname);
               
	       if(strcmp(musique->ins[i].iname,"")==0)
 		  {
			midi_instruments[i] = 0;		//instrument 0
			continue;
		  }

               if(xins[i]!=-1)   //s'il a spcifie dans l'argument un instrument il le prend
                {
                        midi_instruments[i] = xins[i];
                        continue;
                }

	       //prend un instrument de le base de donne
               readini(ini_file,musique->ins[i].iname,buffer);
               mysplit(buffer2,buffer,0,"-");
               mysplit(buffer3,buffer,1,"-");
               strcpy(buffer,buffer2);       //aprs mysplit car on travaille sur le var buffer

               trim(buffer3);
               lcase(buffer3);
               if(strcmp(buffer3,"")!=0 && buffer3[0]!='x')        //si percussion
                {
                        trim(buffer3);
                        lcase(buffer3);
                        temp = atoi(buffer3);   //prend le numro d'instrument percussi
                        percussi[i] = 1;
                        percu_note[i] = (unsigned char)temp;
                }
               /*else     //si pas de percussion
                {
                        //percussi[i] = 0;        //le met en false mme si elle est true alors BYE !!!
                        //percu_note[i] = 0;
                }*/

               if(strcmp(buffer,"")==0)    //si le buffer est vide
                {
                     if(noinput==0)
                       {
                        printf("L'instrument \"%s\" dans le channel %i n'est pas inscrit dans le fichier \"%s\" entrez le numro d'instrument: ",musique->ins[i].iname,i,ini_file);
                        mgets(buffer,3);
                       }
                     else
                       {
                         strcpy(buffer,"1");    //met l'instrument 1 si pas de INPUT
                       }
                }

	       midi_instruments[i] = atoi(buffer);        //met l'instrument lu
          }

	
}

//#############################################################
// Le mme que "write" du C mais au format du MIDI
//#############################################################
int mywrite(int fd, const void *buffer, int count)
{
        int max=0,i=0;
        char *buffer2 = (char *) buffer;

        if(count==0) return 0;

        for(i=count-1;i>=0;i--)
           {
                max+=write(fd,(char *)&buffer2[i],sizeof(char));
           }
	
        return max;
}

//#############################################################
// crit un text event avec la commande COMMAND
//#############################################################
void text_event(char command,char *text)
{
        char text_event_command[] = {0x00,0xFF,command};     //la commande du copyright
        char len;

        len = (unsigned char)strlen(text);
        lenght_of_track+=write(file,text_event_command,3);      //la commande
        lenght_of_track+=write(file,&len,1);                    //le size du string
        lenght_of_track+=write(file,text,len);   //crit le string
}

//#############################################################
// crit le header du MIDI
//#############################################################
void write_header(void)
{
        char *fmsong_header = "Music written with FmSong \"http://fmsong.cjb.net\" Copyright (c) Achraf cherti 2001";
        char midi_option[] = {
		                 //0x00,0xFF,0x7F,0x03,0x00,0x00,0x41,
				 //0x00,0xFF,0x51,0x03,0x06,0xAA,0x80,       //tempo
                                 0x00,0xFF,0x58,0x04,0x04,0x02,0x60,0x08,  //time signature
                                 0x00,0xFF,0x59,0x02,1,0x00,               //key signature
                                 //0x00,0xFF,0x7F,0x05,0x00,0x00,0x77,0x0E,
                                 0x00
			     };  //un str avec ascii zero pour les options du midi

        //Enlve les espaces
        trim(musique->auteur);
        trim(musique->titre);
        trim(musique->commentaire);

	write(file,header,len_header);
        mywrite(file,(short *)&midi_format,sizeof(short));

        //le maxtrack
        write(file,(char *)&zero,sizeof(char));
        write(file,(char *)&max_track,sizeof(char));

        //le delta time
        mywrite(file,(short *)&principal_deltatime,sizeof(short));

        //debut du track
        write(file,track_header,len_header2);

        pos_lenght_of_track = tell(file);
        write(file,&zero,sizeof(char));
        write(file,&zero,sizeof(char));
        write(file,&zero,sizeof(char));
        write(file,&zero,sizeof(char));

        lenght_of_track+=write(file,midi_option,strlen(midi_option));      //les options

        //crit le copyright+commantaires...
        text_event(0x01, fmsong_header);          //Le header
        text_event(0x04, musique->auteur);        //0x04 copyright
        text_event(0x03, musique->titre);         //0x03 Nom de la musique
        text_event(0x01, musique->commentaire);   //0x01 textevent commentaire

}

//#############################################################
// crit la fin du track dans le fichier MIDI
//#############################################################
void write_eof(void)
{

        lenght_of_track+=write(file,end_of_track,3);

        zero = 0;
        write(file,&zero,sizeof(char));
        lenght_of_track++;

        write_lenght_of_track();
}

//#############################################################
// Ecrit le lenght du track  la fin de la conversion
//#############################################################
void write_lenght_of_track(void)
{
        int save_position = tell(file);
        char save_zero = zero;
        zero = 0;

        lseek(file, pos_lenght_of_track, SEEK_SET);
        mywrite(file,&lenght_of_track,sizeof(long));

        zero = save_zero;

        lseek(file, save_position, SEEK_SET);
}

//#############################################################
// Changer l'instrument dans le MIDI
//#############################################################
void changer_instrument(char channel,char instrument)
{
        char command=0;
        char xzero = 0;
        write(file,(char *)&xzero,1);

        if(channel>15) channel=15;
        command = (0xC<<4)+channel;
        write(file,(char *)&command,1);
        
        write(file,(char *)&instrument,1);

        lenght_of_track+=3;
}
//#############################################################
// Relache un boutton du syntetiseur MIDI
//#############################################################
void keyboardoff(char channel,char note,char velocity)
{
        char command=0;

        if(channel>15) channel=15;
        command = (8<<4)+channel;
        write(file,(char *)&zero,1);

        write(file,(char *)&command,1);
        write(file,(char *)&note,1);
        write(file,(char *)&velocity,1);

        lenght_of_track+=4;
}
//#############################################################
// Presse un boutton dans le syntetiseur MIDI
//#############################################################
short keyboardon(char channel,char note,char velocity)
{
        char command=0;
        char temp;
	short ret=0;

        temp = zero;
        zero=0;
        //keyboardoff(channel,note,velocity);
        zero = temp;

        temp = zero;
        zero=0;
//        controlchange(channel,0x79,0x00);
        zero = temp;
        write(file,(char *)&zero,1);

        if(channel>15) channel=15;
        command = (9<<4)+channel;

        write(file,(char *)&command,1);
        write(file,(char *)&note,1);
        ret = write(file,(char *)&velocity,1);

        temp = zero;
        zero=0;
//        controlchange(channel,0x07,0x64);
        zero = temp;
        lenght_of_track+=4;
	return ret;	//si erreur alors 0 ou -1
}

//#############################################################
// Changement du controle
//#############################################################
void controlchange(char channel,char controllernumber,char newvalue)
{
        char command=0;
        write(file,(char *)&zero,1);

        if(channel>15) channel=15;
        command = (0xB<<4)+channel;    //met la commande

        write(file,(char *)&command,1);
        write(file,(char *)&controllernumber,1);
        write(file,(char *)&newvalue,1);

        lenght_of_track+=4;
}

//#############################################################
// Changement du pitch
//#############################################################
void pitchchange(char channel,char bb,char ff)
{
        char command=0;
        write(file,(char *)&zero,1);

        if(channel>15) channel=15;
        command = (0xE<<4)+channel;    //met la commande

        write(file,(char *)&command,1);
        write(file,(char *)&bb,1);
        write(file,(char *)&ff,1);

        lenght_of_track+=4;
}

//#############################################################################
// Conversion d'une note FMSong (note,diese,octave) en une note MIDI (byte)
//#############################################################################
char fms2midi(char note,char diese,char octave)
{
             char position=0;
             if(note==0) return 0;

             if(note>7)
                       note=7;
	     
 	     if(special==1)
			octave++;
	
             if(diese!=0) diese=1;
             //parceque le table commence par 0 alors +=6 et pas 7
             if(diese==1)
                         position =  note-1+7;
             else
                         position = note-1;

             //position = note%2;
             
             if(notemap[position]!=-1)      //il y a diese
                                  return notemap[position]+(12*octave)+1;
             else
                                  return -1;     //si -1

}

#endif
