//#####################################################################
// FmsInfo Copyright (c) Achraf cherti 2001
// Utilitaire pour Mettre les infos d'un FMS dans un fichier
//
// Email:  achrafcherti@hotmail.com
// FmSong: http://fmsong.cjb.net
//#####################################################################

#include <stdio.h>
#include <stdlib.h>
#include "mystring.h"
#include "fmlib.h"

//vars
FMS *music = 0;
char ret=0;
FILE *filed = 0;

char bienvenue[] =
"FmsInfo version 2.1, Copyright (c) Achraf cherti 2001

";
char syntaxe[] =
"Syntaxe de FmsInfo:
         -------------------------------------------------------------------
               FmsInfo.exe <fichier.fms> <info.txt> /option1 /option2...
         -------------------------------------------------------------------
Options:
                /noinput        Ne pas demander la confirmation d'crasement
                                du fichier cible (s'il existe)...
Astuce:
                Si vous mettez  la place de \"info.txt\" -default il change 
                l'extention de fichier.fms en fichier.txt automatiquement.
";

//############################################################
// Desallocation quand on quitte
//############################################################
void bye(void)
{
     if(music!=0) freefms(music);
     free(music);
}

//############################################################
// Main
//############################################################
int main(int argc,char **argv)
{
        char *fichierd;
        short minute,seconde,delay;
        char noinput = 0;
        struct date d;
        struct time t;
        short i;
        music = (FMS *) malloc(sizeof(FMS));
        atexit(bye);    //sub bye

        getdate(&d);
        gettime(&t);

        //message de bienvenue
        printf("%s",bienvenue);

        if(music==0)
               {
                        printf("Pas assez de mmoire pour executer le programme...\n");
                        exit(1);
               }
        if(argc<2)     //si fichier seulement
         {
           printf("%s",syntaxe);
           exit(0);
         }
        if(argc==2)
         {
                printf("Vous devez spcifier le fichier cible...\n");
                exit(0);
         }

        for(i=3;i<argc;i++)
         {
                trim(argv[i]);
                lcase(argv[i]);
                if(strcmp(argv[i],"/noinput")==0)
                                         noinput = 1;
                else
                 {
                    printf("FmsInfo ne reconnait pas l'option: \"%s\"...\n",argv[i]);
                    exit(1);
                 }

         }

        ret = loadfms(music,argv[1]);
        if(ret)
         {
              printf("Erreur dans l'ouverture du FMS: \"%s\", ",argv[1]);
              print_loadfms_error(ret);
              printf("...\n");
              exit(1);
         }

        trim(argv[2]);
        lcase(argv[2]);

        if(strcmp(argv[2],"-default")==0)       //si default
            {
                 fichierd = (char *) malloc(strlen(argv[1])+1+4);
                 changer_ext(argv[1], fichierd, "txt");
            }
        else
            {
                 fichierd = (char *) malloc(strlen(argv[2])+1);
                 strcpy(fichierd, argv[2]);
            }

        if(__file_exists(fichierd) && !noinput)
         {
                printf("Le fichier \"%s\" existe dja, l'craser [O/N]? ",fichierd);
                if(choice("o,n")==1)
                 {
                  exit(0);
                 }
                CRLF();
         }

        printf("Ecriture des infos du FMS \"%s\" dans \"%s\" en cours...\n",argv[1],fichierd);
        filed = fopen(fichierd,"w");

        fprintf(filed,
"=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Fichier cree avec le programme \"fmsinfo.exe\"
Copyright (c) Achraf cherti 2001

Informations du fichier: \"%s\"
Cree le %i/%i/%i a %i:%i:%i.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

",argv[1],d.da_day,d.da_mon,d.da_year,t.ti_hour,t.ti_min,t.ti_sec);
        trim(music->auteur);
        trim(music->titre);
        trim(music->commentaire);

        fprintf(filed,"-----------------\n");
        fprintf(filed,"Proprietes:\n");
        fprintf(filed,"-----------------\n");

        fprintf(filed,"Auteur:       \"%s\"\n",music->auteur);
        fprintf(filed,"Titre:        \"%s\"\n",music->titre);
        fprintf(filed,"Commentaire:  \"%s\"\n\n",music->commentaire);

        fprintf(filed,"-----------------\n");
        fprintf(filed,"Instruments:\n");
        fprintf(filed,"-----------------\n");
        fprintf(filed," -----------      --------------    \n");
        fprintf(filed,"   Channel          Instrument      \n");
        fprintf(filed," -----------      --------------    \n");

        for(i=0;i<8;i++)        //affiche les instruments
            {
              trim(music->ins[i].iname);

              if(strcmp(music->ins[i].iname,"")==0)
                                        strcpy(music->ins[i].iname,"!NONE");

              fprintf(filed,"      %i              %s\n",i+1,music->ins[i].iname);
            }
        fprintf(filed,"\n");

        fprintf(filed,"-----------------\n");
        fprintf(filed,"Info Technique:\n");
        fprintf(filed,"-----------------\n");
        fprintf(filed,"Tracks: %i\n",music->maxtrack);
        fprintf(filed,"Time:   ");

        // Ici il met le temps MAX du FMS
        delay = 0;
        for(i=0;i<music->maxtrack;i++)
                                delay = delay + ((music->track[i].trackdelay>>1)*music->track[i].maxnote);

        seconde = (short)(delay/20);    //convertit le delay en seconde
        minute  = (short)(seconde/60);  // convertit seconde en minute

        if(minute!=0)   //si pas de minutes
           {
                seconde = seconde%60;   //enlve les econdes des minutes
                fprintf(filed,"%i Min ",minute);
           }

        if(seconde!=0) fprintf(filed,"%i Sec",seconde);

        fprintf(filed,"\n\n");

        fprintf(filed," ---------   --------  -----------------------\n");
        fprintf(filed,"   Track      Delay       Maximum de notes    \n");
        fprintf(filed," ---------   --------  -----------------------\n");
        for(i=0;i<music->maxtrack;i++)
         {
                   fprintf(filed,"    %i           %i              %i\n",i+1,music->track[i].trackdelay>>1,music->track[i].maxnote);
         }

        fclose(filed);
        free(fichierd);
        return 0;
}
