//#####################################################################
// Programme MAKE pour les fichier *.f2m, utilise le convertisseur
// FMS-->MIDI Fms2Mid.
// MakeMid Copyright (c) Achraf cherti 2001
//
// Email:   achrafcherti@hotmail.com
// FmSong:  http://fmsong.cjb.net
//#####################################################################

#include <stdlib.h>    // atexit
#include <stdio.h>     // printf
#include <unistd.h>    // __file_exists
#include "mystring.h"  //gestion avance de chaines de caractaire

//####################################################################
// Les vars
//####################################################################
char *path = (char *) 0;
char *fms2mid = (char *) 0;
char commande[1024];
short i,max=-1;
char **myarg = (char **) 0;
char *exe_name = "fms2mid.exe";
char *makemid = "makemid.f2m";     //fichier
char enabled[256],file[256],midi[256],mode[256],special[256],ins[256],volume[256];
char buffer[1024];
short size;
//####################################################################

//####################################################################
// Pour quitter
//####################################################################
void bye(void)
{
     if(!path) free(path);
     if(!fms2mid) free(fms2mid);
     if(max>=0 && myarg!=0)
     {
        for(i=0;i<max;i++)
         {
        //        free(myarg[i]);
         }
         //free(myarg);
     }
}

//####################################################################
// Main
//####################################################################
int main(int argc,char *argv[])
{
        int j;

        atexit(bye);    //quand il quitte bye

        path = dirname(argv[0]);
        fms2mid = (char *) malloc(strlen(path)+strlen(exe_name)+2);

        if(argc<=1)
         {
           printf("MakeMid v2.1, Copyright (c) Achraf cherti 2001\n");
           printf("\n");
         }

        if(!path || !fms2mid)
         {
              printf("Pas assez de mmoire pour l'allocation...\n");
              exit(1);
         }

        sprintf(fms2mid,"%s/%s",path,exe_name);  //cre le chain complet

        if(!__file_exists(fms2mid))
        {
                printf("Fms2Mid: \"%s\" est introuvable.\n",fms2mid);
                exit(1);
        }

        if(argc>1)      //si argument
                  strcpy(makemid,argv[1]);

        j = lastof(ENDOFSTRING,makemid,".");
        if(j==0)        //si pas de point
         {
                        strcat(makemid,".f2m");    //met l'extention automatique
         }

        if(!__file_exists(makemid))
         {
                printf("Le fichier make: \"%s\" n'existe pas...\n",makemid);
                exit(1);
         }

        //lit dans le fichier les variables
        readini(makemid,"enabled",enabled);
        readini(makemid,"mode",mode);
        readini(makemid,"fms",file);
        readini(makemid,"midi",midi);
        readini(makemid,"volume",volume);
        readini(makemid,"ins",ins);

        trim(mode);
        trim(file);
        trim(midi);
        trim(volume);
        trim(ins);

        //si pas de fichier dans la variable "fms"
        if(strcmp(file,"")==0)
        {
                printf("Aucun fichier dans la variable \"fms\" dans le fichier \"%s\"...\n",makemid);
                exit(1);
        }
        // teste l'existance des fichiers
        if(!__file_exists(file))
          {
                printf("Erreur le fichier FMS: \"%s\" n'existe pas...\n",file);
                exit(1);
          }

        if(strcmp(midi,"")==0)
                              strcpy(midi,"-default");
        
        //ici il cre la commande
        sprintf(commande,"%s %s",file,midi);

        //prend le mode
        if(strcmp(mode,"")!=0)  //si le mode != ""
         {
           lcase(mode);
           if(strcmp(mode,"special")==0)
                                    strcat(commande," /mode special");
           else if(strcmp(mode,"normal")==0)
                                    strcat(commande," /mode normal");
           else
               {
                   printf("Erreur dans \"mode\" vous devez mettre \"special\" ou \"normal\".\n");
                   exit(1);
               }
         }

        // teste le volume
        if(strcmp(volume,"")!=0)        //si pas ""
         {
          if(maxsplit(volume,"")==0)
            {
               printf("Erreur dans le volume \"%s\" au moin un canal...\n",volume);
            }
          else
            {
               strcat(commande," /volume ");
               strcat(commande,volume);
            }
         }


       // teste le volume
       if(strcmp(ins,"")!=0)    //si pas ""
       {
        if(maxsplit(ins,"")==0 && strcmp(ins,"")!=0)
          {
           printf("Erreur dans INS: \"%s\" au moin un Instrument...\n",ins);
          }
        else
          {
             strcat(commande," /ins ");
             strcat(commande,ins);
          }
       }
       strcat(commande," /noinput");  //pas d'input
       strcat(commande," /noprint");  //pas d'affichage

       trim(enabled);
       if(strcmp(enabled,""))   //met enabled
         {
           lcase(enabled);
           strcat(commande," /enabled ");
           strcat(commande,enabled);
         }

       max = maxsplit(commande," ");
       myarg = (char **) malloc((sizeof(char *)*max)+2);
       myarg[0] = "fms2mid";
       for(i=0;i<max;i++)
         {
                mysplit(buffer,commande,i," ");
                trim(buffer);
                myarg[i+1] = (char *) malloc(strlen(buffer)+1);
                strcpy(myarg[i+1],buffer);
         }
        myarg[i+1] = 0;
        //myarg[i+1] = (char *) malloc(1);
        //myarg[i+1] = 0;
        execvp("fms2mid",myarg);

        getch();
        return 0;
}
